//+------------------------------------------------------------------+
//|                                               CreateElements.mqh |
//|                                      Copyright 2017, nicholishen |
//|                         https://www.forexfactory.com/nicholishen |
//+------------------------------------------------------------------+
#property copyright "Copyright 2017, nicholishen"
#property link      "https://www.forexfactory.com/nicholishen"
#property version   "1.00"
#property strict
#include "paneldialog.mqh"




bool CPanelDialog::Create(const long chart,const string name,const int subwin,const int x1,const int y1,const int x2,const int y2)
{
//--- calling the parent class method
   if(!CAppDialog::Create(chart,name,subwin,x1,y1,x2,y2)) 
      return(false);
   if(!CreateTradeButtons())
      return false;
   if(!CreateEditLots())
      return false;
   if(!CreateLabels())
      return false;
   if(!CreateEditTargets())
      return false;
   if(!CreateCheckBoxes())
      return false;
   if(!CreateReconcileButton())
      return false;
//--- creating additional controls

   return(true);
}

bool CPanelDialog::CreateReconcileButton()
{
   int x1=INDENT_LEFT;
   int y1=INDENT_TOP*5+EDIT_HEIGHT*7;
   int x2=x1+EDIT_WIDTH*2+INDENT_LEFT;
   int y2=y1+EDIT_HEIGHT;
   if(!m_button_reconcile.Create(m_chart_id,m_name+"_reconcile_button",m_subwin,x1,y1,x2,y2))
      return false;
   m_button_reconcile.Text("Order Maintenance");
   if(!Add(m_button_reconcile))                                                            
      return(false);
   return true;
}

bool CPanelDialog::CreateCheckBoxes()
{
   int x1=INDENT_LEFT;
   int y1=INDENT_TOP*6+EDIT_HEIGHT*8;
   int x2=x1+EDIT_WIDTH*2+INDENT_LEFT;
   int y2=y1+EDIT_HEIGHT;
   if(!m_check_magic.Create(m_chart_id,m_name+"_check_magic",m_subwin,x1,y1,x2,y2))
      return false;
   if(!m_check_magic.Text("Only manage panel orders"))return false;
   if(!m_check_magic.Checked(false))return false;
   m_locked_magic = false;
   if(!Add(m_check_magic))                                                            
      return(false);
   return true;
}

bool  CPanelDialog::CreateTradeButtons(void)
{
   int x1=INDENT_LEFT;
   int y1=INDENT_TOP*2+EDIT_HEIGHT*2;
   int x2=x1+EDIT_WIDTH;
   int y2=y1+EDIT_HEIGHT*2;
   if(!m_button_sell.Create(m_chart_id,m_name+"_sell_button",m_subwin,x1,y1,x2,y2))
      return false;
   m_button_sell.Text("SELL");
   x1=x2+INDENT_LEFT;
   x2=x1+EDIT_WIDTH;
   if(!m_button_buy.Create(m_chart_id,m_name+"_buy_button",m_subwin,x1,y1,x2,y2))
      return false;
   m_button_buy.Text("BUY");
   
   x1=INDENT_LEFT;
   y1=INDENT_TOP+y2;
   x2 = x1+EDIT_WIDTH;
   y2 = y1+EDIT_HEIGHT;
   if(!m_button_reverse.Create(m_chart_id,m_name+"_rev_button",m_subwin,x1,y1,x2,y2))
      return false;
   m_button_reverse.Text("REVERSE");
   
   x1=x2+INDENT_LEFT;
   x2 = x1+EDIT_WIDTH;
   
   if(!m_button_close.Create(m_chart_id,m_name+"_close_button",m_subwin,x1,y1,x2,y2))
      return false;
   m_button_close.Text("CLOSE ALL");
   
   m_button_sell.ColorBackground(clrRed);
   m_button_buy.ColorBackground(clrDodgerBlue);
   m_button_buy.Color(clrWhiteSmoke);
   
   if(!Add(m_button_buy)||!Add(m_button_sell)||!Add(m_button_reverse)||!Add(m_button_close))                                                            
      return(false);
   return true;
}

bool CPanelDialog::CreateEditTargets(void)
{
   int x1=INDENT_LEFT*2+EDIT_WIDTH;
   int y1=INDENT_TOP*1+EDIT_HEIGHT;
   int x2=x1+EDIT_WIDTH/2-INDENT_LEFT/2;
   int y2=y1+EDIT_HEIGHT;
   
   if(!m_edit_stop.Create(m_chart_id,m_name+"_spin_stop_",m_subwin,x1,y1,x2,y2))
      return false;
   
   x1 = x2 + INDENT_LEFT;
   x2 = x1 + EDIT_WIDTH/2-INDENT_LEFT/2;
   if(!m_edit_take.Create(m_chart_id,m_name+"_spin_take_",m_subwin,x1,y1,x2,y2))
      return false;
   //m_edit_stop.MinValue((int)SymbolInfoInteger(_Symbol,SYMBOL_TRADE_STOPS_LEVEL));
   //m_edit_stop.MaxValue(1000);
   //m_edit_stop.Value(10);
   if(!Add(m_edit_stop))                                                            
      return(false);
   if(!Add(m_edit_take))                                                            
      return(false);
   return true;
}


bool  CPanelDialog::CreateEditLots(void)
{
   int x1=INDENT_LEFT;
   int y1=INDENT_TOP*1+EDIT_HEIGHT;
   int x2=x1+EDIT_WIDTH;
   int y2=y1+EDIT_HEIGHT;
    if(!m_button_dnlots.Create(m_chart_id,m_name+"_lots_dn",m_subwin,x1,y1,x2,y2))
      return false;
   if(!Add(m_button_dnlots))                                                            
      return(false);
   m_button_dnlots.BmpNames("::res\\down_black20.bmp","::res\\blank.bmp");
   
   x1+=20;
   x2=x1+EDIT_WIDTH-40;
   //if(!m_label_lots.Create(m_chart_id,m_name+"_lots_label",m_subwin,x1,y1,x2,y2))
   //   return false;
   //if(!Add(m_label_lots))                                                            
   //   return(false);
   //m_label_lots.Text("Lots");
   //x1+=LABEL_WIDTH+CONTROLS_GAP_X;
   //x2=x1+EDIT_WIDTH;
   if(!m_edit_lots.Create(m_chart_id,m_name+"_lots_edit",m_subwin,x1,y1,x2,y2))
      return false;
   if(!Add(m_edit_lots))                                                            
      return(false);  
   
   x1=x2;
   x2=x1+20;
    if(!m_button_uplots.Create(m_chart_id,m_name+"_lots_up",m_subwin,x1,y1,x2,y2))
      return false;
   if(!Add(m_button_uplots))                                                            
      return(false);
   
   m_button_uplots.BmpNames("::res\\up_black20.bmp","::res\\blank.bmp");

    
   SetLots();
   
   return true;
}

bool  CPanelDialog::CreateLabels(void)
{
   int x1=INDENT_LEFT;
   int y1=INDENT_TOP;
   int x2=x1+EDIT_WIDTH;
   int y2=y1+EDIT_HEIGHT;
   if(!m_label_lots.Create(m_chart_id,m_name+"_label_lots",m_subwin,x1,y1,x2,y2))
      return false;
   x1=x2+INDENT_LEFT;
   x2=x1+EDIT_WIDTH/2;
   if(!m_label_sl.Create(m_chart_id,m_name+"_label_sl",m_subwin,x1,y1,x2,y2))
      return false;
   x1=x2+INDENT_LEFT;
   x2=x1+EDIT_WIDTH/2;
   if(!m_label_tp.Create(m_chart_id,m_name+"_label_tp",m_subwin,x1,y1,x2,y2))
      return false;
      
   x1=INDENT_LEFT;
   x2=x1+EDIT_WIDTH*2+INDENT_LEFT;
   y1 = INDENT_TOP*7+EDIT_HEIGHT*4;
   y2 = y1+EDIT_HEIGHT;
   if(!m_label_result.Create(m_chart_id,m_name+"_label_res",m_subwin,x1,y1,x2,y2))
      return false;
      
   y1+=EDIT_HEIGHT;
   y2 = y1+EDIT_HEIGHT;
   if(!m_net_position.Create(m_chart_id,m_name+"_label_net",m_subwin,x1,y1,x2,y2))
      return false;
   
   
   
   m_label_lots.Text("LOTS");
   m_label_lots.FontSize(8);
   m_label_lots.Font("Consolas");
   m_label_sl.Text("SL");
   m_label_tp.Text("TP");
   m_label_sl.FontSize(8);
   m_label_sl.Font("Consolas");
   m_label_tp.FontSize(8);
   m_label_tp.Font("Consolas");
   
   m_label_result.Font("Consolas");
   m_label_result.FontSize(8);
   m_label_result.Text("Last Result:");
   
   m_net_position.Font("Consolas");
   m_net_position.FontSize(8);
   UpdateNetPosition();
   
   if(!Add(m_label_lots))                                                            
      return(false);
   if(!Add(m_label_sl))                                                            
      return(false);
   if(!Add(m_label_tp))                                                            
      return(false);
   if(!Add(m_label_result))                                                            
      return(false);
   if(!Add(m_net_position))                                                            
      return(false);
   return true;
}